import { Status } from "../../DataFrame";
import { ResponseResult } from "../FieldChangeResult";
import { DeviceTokenMetadata, INotificationsService, NotificationClientRegistration, NotificationsServiceErrorCode } from "./INotificationsService";
export declare class NotificationsService implements INotificationsService {
    static readonly ServiceName: string;
    private _connection;
    private _logger;
    constructor();
    GetServiceName(): string;
    RegisterNotificationsClientAsync(registration: NotificationClientRegistration): Promise<string | ResponseResult<NotificationsServiceErrorCode>>;
    UpdateNotificationsClientAsync(tokenGuid: string, registration: NotificationClientRegistration): Promise<Status.OK | ResponseResult<NotificationsServiceErrorCode>>;
    GetRegisteredNotificationsClientsMetadataAsync(): Promise<DeviceTokenMetadata[] | ResponseResult<NotificationsServiceErrorCode>>;
    IsNotifiacationsEnabledAsync(tokenIdentity: string): Promise<boolean | ResponseResult<NotificationsServiceErrorCode>>;
    EnableNotificationsAsync(tokenIdentity?: string): Promise<Status.OK | ResponseResult<NotificationsServiceErrorCode>>;
    DisableNotificationsAsync(tokenIdentity?: string): Promise<Status.OK | ResponseResult<NotificationsServiceErrorCode>>;
    private getClientType;
    private isValidErrorCode;
}
